.386
.model flat,stdcall
option casemap:none

include POP3overSSL.inc
include POP3.asm

.code

start:

	invoke GetModuleHandle,NULL
	mov hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	mov CommandLine,eax
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX,msg:MSG

	mov wc.cbSize,sizeof WNDCLASSEX
	mov wc.style,CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc,offset WndProc
	mov wc.cbClsExtra,NULL
	mov wc.cbWndExtra,DLGWINDOWEXTRA
	push hInst
	pop wc.hInstance
	mov wc.hbrBackground,COLOR_BTNFACE+1
;	mov wc.lpszMenuName,IDM_MENU
	mov wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov wc.hIcon,eax
	mov wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	jmp @2
	
@1:
	invoke TranslateMessage,addr msg
	invoke DispatchMessage,addr msg
@2:
	invoke GetMessage,addr msg,NULL,0,0
	test eax,eax
	jne @1
	
	mov eax,msg.wParam
	ret

WinMain endp

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

	mov eax,uMsg
	cmp eax,WM_INITDIALOG
	je @WM_INITDIALOG
	cmp eax,WM_COMMAND
	je @WM_COMMAND
	cmp eax,WM_CLOSE
	je @WM_CLOSE
	cmp eax,WM_DESTROY
	je @WM_DESTROY
	invoke DefWindowProc,hWin,uMsg,wParam,lParam
	ret
	
@EXIT:
	xor eax,eax
	ret
	
;========== Init dialog
@WM_INITDIALOG:
	push hWin
	pop hWnd
	jmp @EXIT
	
;========== Command
@WM_COMMAND:
	mov	eax,wParam
	mov edx,eax
	shr edx,16
	cmp dx,BN_CLICKED
	je @BN_CLICKED
;	cmp dx,CBN_SELCHANGE
;	je @selchange
	jmp @EXIT
	
@BN_CLICKED:
	cmp ax,ID_GET
	je @ID_GET
	cmp ax,ID_CLOSE
	je @ID_CLOSE
	jmp @EXIT
	
@ID_GET:
	invoke GetDlgItemText,hWin,ID_PORT,offset _server,sizeof _server
	test eax,eax
	je @err_input
	invoke atodw,offset _server
	mov _port,eax					; get the port number, convert to hex
	
	invoke GetDlgItemText,hWin,ID_USERNAME,offset _username,sizeof _username
	test eax,eax
	je @err_input					; get the username
	
	invoke GetDlgItemText,hWin,ID_PASSWORD,offset _password,sizeof _password
	test eax,eax
	je @err_input					; get the password
	
	invoke GetDlgItemText,hWin,ID_SERVER,offset _server,sizeof _server
	test eax,eax
	je @err_input					; get the server
	
	call POP3SSL
	jmp @EXIT
	
@err_input:
	invoke MessageBox,hWin,offset input_error,0,0
	jmp @EXIT
	
@ID_CLOSE:
	invoke SendMessage,hWin,WM_CLOSE,0,0
	
;========== Close
@WM_CLOSE:
	invoke DestroyWindow,hWin
	jmp @EXIT
	
;========== Destroy
@WM_DESTROY:
	invoke PostQuitMessage,NULL
	jmp @EXIT
	
WndProc endp

end start
