
CyaSSL_Init							PROTO

CyaSSLv23_client_method				PROTO
CyaSSLv3_client_method				PROTO

CyaTLSv1_client_method				PROTO
CyaTLSv1_1_client_method			PROTO
CyaTLSv1_2_client_method			PROTO

CyaDTLSv1_client_method				PROTO

CyaSSL_CTX_new						PROTO method:DWORD
CyaSSL_CTX_load_verify_locations	PROTO ctx:DWORD,pFile:DWORD,pPath:DWORD
CyaSSL_CTX_use_certificate_file		PROTO ctx:DWORD,pFile:DWORD,type_:DWORD
CyaSSL_CTX_use_certificate_chain_file	PROTO ctx:DWORD,pFile:DWORD
CyaSSL_CTX_set_verify				PROTO ctx:DWORD,flag:DWORD,:DWORD

CyaSSL_new							PROTO ctx:DWORD
CyaSSL_set_fd						PROTO ssl:DWORD,sock:DWORD
CyaSSL_check_domain_name			PROTO ssl:DWORD,pDomain:DWORD
CyaSSL_connect						PROTO ssl:DWORD

;CyaSSL_connect PROTO ssl:DWORD
;CyaSSL_get_cipher PROTO ssl:DWORD
CyaSSL_write						PROTO ssl:DWORD,pReq:DWORD,sizeReq:DWORD
CyaSSL_read							PROTO ssl:DWORD,pBuf:DWORD,sizeBuf:DWORD
CyaSSL_shutdown PROTO ssl:DWORD

CyaSSL_free							PROTO ssl:DWORD
CyaSSL_CTX_free						PROTO ctx:DWORD
CyaSSL_Cleanuo						PROTO

CyaSSL_ERR_error_string				PROTO err:DWORD,pBuf:DWORD
CyaSSL_get_error					PROTO ssl:DWORD,err:DWORD

CyaSSL_Debugging_ON					PROTO
CyaSSL_Debugging_OFF				PROTO
CyaSSL_SetLoggingCb					PROTO func:DWORD

MD5 			equ 0
MD5_BLOCK_SIZE	equ 64
MD5_DIGEST_SIZE	equ 16
MD5_PAD_SIZE	equ 56

MD_5 struct
	buffLen		dd ?
	loLen		dd ?
	hiLen		dd ?
	digest		db MD5_DIGEST_SIZE		dup(?)
	buffer		db MD5_BLOCK_SIZE		dup(?)
MD_5 ends

InitMd5								PROTO pMD5:DWORD
Md5Update							PROTO pMD5:DWORD,pString:DWORD,str_len:DWORD
Md5Final							PROTO pMD5:DWORD,:DWORD

SSL_SUCCESS			equ	1
SSL_FAILURE			equ 0

SSL_FILETYPE_PEM	equ 1
SSL_VERIFY_NONE		equ 0
SSL_VERIFY_PEER		equ 1
